// UP_lib.cpp : Definition der Funktionen für die statische Bibliothek UP_lib
// ================ Include-Files =============================================
#include "pch.h"
#include "framework.h"
#include "UPfunct.h"
//
// #include "UP.h"
// ===========================================================================
// Dies sind die Bibliotheksfunktionen!
// ============================================================================
long double P0048(int &jahr,int &monat,int &tag,
                               int &stunde,int &minute,int &sekunde, int zweig)
// FUNKTION: Datum, Zeit und Zeitstempel ermitteln
// ============================================================================
// Copyright: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Erkrath/Darmstadt
// Lehr- und Studienprogramm - kommerzielle Nutzung nicht gestattet. 
// Der Autor uebernimmt keine Haftung fuer Unvollkommenheit und Fehler!
// Version:  1996, 2021
// Compiler: C++
// ---------------------------------------------------------------------------
// PARAMETER:
// zweig (int)= 0 Datum, Uhrzeit und Zeitstempel ermitteln
//            = 1 Datum und Uhrzeit seit Jobanfang liefern (*** NICHT REALISIERT)
//            = 2 Datum und verfügbare Zeit bis Jobende    (*** NICHT REALISIERT)
// ERGEBNIS:
// P0048 = Zeitstempel in Sekunden
//   JAHR,  MONAT,     TAG (int) = Datum
// STUNDE, MINUTE, SEKUNDE (int) = Uhrzeit
// ----------------------------------------------------------------------------
{
   long double sekdezi = 0.0L;
   jahr=0;   monat=0;  tag=0; stunde=0; minute=0; sekunde=0;
   // -------------------------------------------------------------------------
   bool FEHLER;
   FEHLER = false;
   //*** FEHLER = true;
   if (FEHLER) std::cout << "P0048: Fehler = " << FEHLER << endl;
   //==========================================================================
   struct tm newtime;
   struct _timeb timebuffer;
// -------------------------
   errno_t err;
   __time64_t long_time;
   _time64(&long_time);
   _ftime64_s(&timebuffer);
// lokale Zeit
// ===========
   err=_localtime64_s(&newtime, &long_time);
// ----------------------------------------------------------------------------
if(zweig == 0)
{
   jahr  = newtime.tm_year+1900;
   monat = newtime.tm_mon+1;
   tag   = newtime.tm_mday;
   //
   stunde  = newtime.tm_hour;
   minute  = newtime.tm_min;
   sekunde = newtime.tm_sec;
   //
if (FEHLER) std::cout << "P0048: "
  <<"Stunde " << stunde << " Minute " << minute << " Sekunde " <<sekunde<<'\n';
// ============================================================================
    // Clocks in Millisekunden ermitteln
    long double tstart = 0.0L, millisek = 0.0L;
    // tstart
    tstart = clock();
if (FEHLER) cout << " clock " << tstart<<endl;
if (FEHLER) cout << " Clock in Millisekunden " << tstart << endl;
// 
    // Zeit in Sekunden
    tstart = tstart/CLOCKS_PER_SEC;
if (FEHLER) cout << " Clock in Sekunden " << tstart << endl;
// 
    // Zeitbruchteile in Millisekunden
    millisek = timebuffer.millitm/1000.0L;
if (FEHLER) cout << " Zeitanteil in Millisekunden " << millisek << endl;
// 
// Sekundenbruchteile addieren
    sekdezi = tstart + millisek;
if (FEHLER) std::cout<<"P0048: Zeitstempel in Sekunden mit Dezimalen " <<sekdezi<<'\n';
};
// ----------------------------------------------------------------------------
return sekdezi;
}
// ===========================================================================
//
long double R0048(int& std, int& min, int& sek,
                  long double asek, long double esek)
// Funktion: Rechenzeit ermitteln
// ============================================================================
// Urheberrechte: Univ.-Prof. Dr.-Ing. Udo F. Meissner, Darmstadt
// Version:  3/1996
// Compiler: C++
// ============================================================================ 
// PARAMETER:
// ==========
// azenti, ezenti: Anfangs-/End-Zeitstempel in Sekunden
//
// ERGEBNIS:
// =========
// R0048 (long double): Rechenzeit in Sekunden
// std (int):                         Stunden
// min (int):                         Minuten
// sek (int):                         Sekunden
// ----------------------------------------------------------------------------
{
std = 0;  min = 0; sek = 0;
int lsek, lmin, lstd;
long double sekdezi = 0.0L, sekunden;
// -------------------------------------------------------------------------
bool FEHLER;
FEHLER = false;
//*** FEHLER = true;
if (FEHLER) std::cout << "P0048: Fehler = " << FEHLER << endl;
//==========================================================================
if (FEHLER) std::cout 
            << "R0048: Anfangszeit: " << asek<<"s Endzeit: "<<esek<<"s"<<'\n';
// ---------------------------------------------------------------------------
// Rechenzeit in Sekunden
sekunden = esek - asek;
sekdezi = sekunden;
if (FEHLER) std::cout 
          << "R0048: Differenz der Zeitstempel in Sekunden" << sekunden<< '\n';
//-----------------------------------------------------------------------------  
// Zeit in Sekunden, Minuten, Stunden berechnen
//
lstd=int(sekunden/3600);
if (FEHLER) cout << "sekunden " << sekunden << " lstd " << lstd << endl;
//
sekunden = sekunden -lstd*3600;
//
lmin=int(sekunden/60);
if (FEHLER) cout << "sekunden " << sekunden << " lmin " << lmin << endl;
//
sekunden =sekunden -lmin*60;
//
lsek=int(sekunden);
if (FEHLER) cout << "sekunden " << sekunden << " lsek " << lsek << endl;
// ---------------------------------------------------------------------------
std=lstd;
min=lmin;
sek=lsek;
//
if (FEHLER) std::cout<<"R0048: Rechenzeit: "
<< lstd <<"h "<< lmin <<" m "<< lsek <<"s Dauer "<< sekdezi <<" secdezi"<<'\n';
// ----------------------------------------------------------------------------
return sekdezi;
}
// ===========================================================================